'----------------------------------------------------------------------------
' DIRECTQB.BI
'   Include file for the DirectQB library version 1.61
'   by Angelo Mottola - Enhanced Creations 1998-99
'
' This file contains constants and function declarations used by the library
' Always include this file into your own programs!
'
' Include file created on 11-10-1999 by the DirectQB Library Manager v1.2
' Run DQBMAN again to modify your DirectQB module settings
'
'  Read DIRECTQB.DOC for detailed informations on how to use the library
'----------------------------------------------------------------------------

#if __FB_LANG__="qb"
  #define qbstr(_N) _N##$
  #define fbstr
  #inclib "directqb"
  '$DYNAMIC
  defint A-Z
  #define i8 __byte
  #define u8 __ubyte
  #define i16 __short
  #define u16 __ushort
  #define i32 __long
  #define u32 __ulong
  #define pu8 u8 __ptr
  #define with __with
  #define screenres __screenres
  #define screenptr __screenptr
  #define screenlock __screenlock
  #define screenunlock __screenunlock
  #define cuint __cuint
  #define cast __cast
  #define cptr __cptr
  #define ptr __ptr
  #define zstring __zstring
  #define asm __asm  
  #define sizeof __sizeof
  #define allocate __allocate
  #define callocate __callocate
  #define deallocate __deallocate
  #define reallocate __reallocate
  #define dir __dir
  #define shl __shl
  #define shr __shr
  #define cvshort __cvshort
  #define setmouse __setmouse
  #define getmouse __getmouse
  #define multikey __multikey
  #define screensync __screensync
  #define flip __flip
  #define screencontrol __screencontrol
#else
  #define qbstr(_N) _N
  #define fbstr as string
  #inclib "directfb"
  #include "crt.bi"
  #define u8 ubyte
  #define i16 short
  #define pu8 u8 ptr
#endif

declare sub dbgprint( s as string )

' Procedures from MAIN.OBJ:
declare function DQBinit (byval NumLayers as integer, byval NumSounds as integer, byval MemSize as integer) as integer
declare function DQBver () as integer
declare function qbstr(DQBid) () fbstr
declare function DQBmapLayer (byval Layer as integer) as integer
declare sub DQBclose ()
declare sub DQBpeek (byval DummyDataSeg as integer, byval DataOff as integer, byval Offset as long, byval Length as integer)
declare sub DQBpoke (byval DummyDataSeg as integer, byval DataOff as integer, byval Offset as long, byval Length as integer)
declare sub DQBsort (byval DummyArraySeg as integer, byval ArrayOff as integer, byval NumRecords as integer, byval RecordLen as integer, byval IndexOff as integer)
declare function DQBangle (byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer) as integer
declare sub DQBinitVGA ()
declare sub DQBinitText ()
declare function DQBsetBaseLayer (byval Layer as integer) as integer
declare sub DQBcopyLayer (byval SourceLayer as integer, byval DestLayer as integer)
declare sub DQBclearLayer (byval Layer as integer)
declare sub DQBwait (byval Times as integer)
declare sub DQBsetFrameRate (byval FPS as integer)
declare function DQBframeReady () as integer
declare function qbstr(DQBerror) () fbstr

' Procedures from DRAW.OBJ:
declare sub DQBcopyTransLayer (byval SourceLayer as integer, byval DestLayer as integer)
declare sub DQBcopyHitLayer (byval SourceLayer as integer, byval DestLayer as integer, byval Col as integer)
declare sub DQBpset (byval Layer as integer, byval x as integer, byval y as integer, byval Col as integer)
declare function DQBpoint (byval Layer as integer, byval x as integer, byval y as integer) as integer
declare sub DQBline (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval Col as integer)
declare sub DQBgline (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval Col1 as integer, byval Col2 as integer)
declare sub DQBellipse (byval Layer as integer, byval x as integer, byval y as integer, byval rx as integer, byval ry as integer, byval Col as integer)
declare sub DQBbox (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval Col as integer)
declare sub DQBboxf (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval Col as integer)
declare sub DQBpaint (byval Layer as integer, byval x as integer, byval y as integer, byval Col as integer)
declare sub DQBscroll (byval Layer as integer, byval dx as integer, byval dy as integer)
declare sub DQBscrollArea (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval Direction as integer)
declare sub DQBsetTransPut ()
declare sub DQBsetSolidPut ()
declare sub DQBget (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval DummyBufSeg as integer, byval pBuf as any ptr)
declare sub DQBput (byval Layer as integer, byval x as integer, byval y as integer , byval DummyBufSeg as integer, byval pBuf as any ptr)

' Procedures from IMAGE.OBJ:
declare function DQBloadImage (byval Layer as integer, byval x as integer, byval y as integer, FileName as string, byref Pal as string, byref imgWidth as integer, byref imgHeight as integer) as integer
declare function DQBsaveImage (Layer as integer, x1 as integer, y1 as integer, x2 as integer, y2 as integer, FileName as string, Pal as string, Format as integer) as integer
declare function DQBplayFLI (FileName as string, BufLayer as integer, KeyStop as integer, LoopFlag as integer) as integer
declare function DQBopenFLI (FileName as string, Frames as integer, Speed as integer) as integer
declare sub DQBplayFLIstep (byval Layer as integer)
declare sub DQBcloseFLI ()

' Procedures from SPRITE.OBJ: 
declare function DQBsize (byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer) as integer
declare sub DQBsetClipBox (byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer)
declare sub DQBfPut (byval Layer as integer, byval x as integer, byval y as integer, byval DummyBufSeg as integer, byval BufOff as any ptr)
declare sub DQBsPut (byval Layer as integer, byval x as integer, byval y as integer, byval DummyBufSeg as integer, byval BufOff as any ptr, byval NewWidth as integer, byval NewHeight as integer)
declare sub DQBrPut (byval Layer as integer, byval x as integer, byval y as integer, byval DummyBufSeg as integer, byval BufOff as any ptr, byval Angle as integer, byval Zoom as integer)
declare sub DQBxPut (byval SourceLayer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval DestLayer as integer, byval x as integer, byval y as integer)
declare sub DQBmPut (byval Layer as integer, byval x as integer, byval y as integer, byval DummyBufSeg as integer, byval BufOff as any ptr, byval flip as integer)
declare sub DQBhPut (byval Layer as integer, byval x as integer, byval y as integer, byval DummyBufSeg as integer, byval BufOff as any ptr, byval Col as integer)
declare sub DQBtPut (byval Layer as integer, byval x as integer, byval y as integer, byval DummyBufSeg as integer, byval BufOff as any ptr, byval BitMode as integer)
declare sub DQBpPut (byval Layer as integer, byval x as integer, byval y as integer, byval DummyBufSeg as integer, byval BufOff as any ptr, byval Pattern as integer)
declare sub DQBputOver (byval DummyBackSeg as integer, byval BackOff as any ptr, byval x as integer, byval y as integer, byval DummyBufSeg as integer, byval BufOff as any ptr)
declare sub DQBsetCollideMethod (byval Method as integer)
declare function DQBcollide (byval x1 as integer, byval y1 as integer, byval DummySeg1 as integer, byval Off1 as any ptr, byval x2 as integer, byval y2 as integer, byval DummySeg2 as integer, byval Off2 as any ptr) as integer
declare function DQBcollideOnLayer (byval Layer as integer, byval x as integer, byval y as integer, byval DummySpriteSeg as integer, byval SpriteOff as any ptr) as integer

' Procedures from BIT.OBJ:
declare function DQBsetBit (byval Value as integer, byval _bit as integer) as integer
declare function DQBresetBit (byval Value as integer, byval _bit as integer) as integer
declare function DQBreadBit (byval Value as integer, byval _bit as integer) as integer
declare function DQBtoggleBit (byval Value as integer, byval _bit as integer) as integer
declare function DQBshiftLeft (byval Value as integer, byval nBits as integer) as integer
declare function DQBshiftRight (byval Value as integer, byval nBits as integer) as integer

' Procedures from PALETTE.OBJ:
declare sub DQBsetCol (byval ColorIndex as integer, byval Red as integer, byval Green as integer, byval Blue as integer)
declare sub DQBgetCol (byval ColorIndex as integer, Red as integer, Green as integer, Blue as integer)
declare function DQBfindCol (byval Red as integer, byval Green as integer, byval Blue as integer) as integer
declare function DQBfindPalCol (Pal as string, Red as integer, Green as integer, Blue as integer) as integer
declare sub DQBsetPal (Pal as string)
declare sub DQBgetPal (Pal as string)
declare sub DQBfadeIn (Pal as string)
declare sub DQBfadeStepIn (Pal as string)
declare sub DQBfadeTo (byval Red as integer, byval Green as integer, byval Blue as integer)
declare sub DQBfadeStepTo (byval Red as integer, byval Green as integer, byval Blue as integer)
declare sub DQBpalOff ()
declare sub DQBpalRotate (byval FirstCol as integer, byval LastCol as integer, byval RotDir as integer)

' Procedures from FONT.OBJ:
declare sub DQBprint (Layer as integer, Text as string, x as integer, y as integer, Col as integer)
declare sub DQBprints (byval Layer as integer, Text as string, byval x as integer, byval y as integer, byval Col as integer, byval Style as integer)
declare function DQBlen (Text as string) as integer
declare sub DQBsetBIOSfont ()
declare function DQBloadFont (FileName as string) as integer
declare sub DQBsetFont (Font as string)
declare sub DQBsetTextStyle (byval Style as integer)
declare sub DQBsetTextBackCol (byval Col as integer)
declare sub DQBsetTextSpacing (byval Spacing as integer)
declare sub DQBsetTextBMap (byval BMap as integer)
declare sub DQBsetFontTexture (byval DummyTextSeg as integer, byval TextOff as any ptr)

' Procedures from DISK.OBJ:
declare function qbstr(DQBdir) (Mask as string, Attributes as integer) fbstr
declare function qbstr(DQBdrive) () fbstr
declare function qbstr(DQBpath) () fbstr
declare function DQBnumDrives ()  as integer
declare sub DQBsetDrive (NewDrive as string)
declare function DQBchDir (NewDir as string) as integer

' Procedures from BLENDING.OBJ:
declare sub DQBfilterBox (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval Col as integer, byval BMap as integer)
declare sub DQBbPut (byval Layer as integer, byval x as integer, byval y as integer, byval DummyBufSeg as integer, byval BufOff as any ptr, byval BMap as integer)
declare sub DQBcopyBlendLayer (byval SourceLayer as integer, byval DestLayer as integer, byval BMap as integer)
declare function DQBcreateBMap (byval BMap as integer, byval FirstCol as integer, byval LastCol as integer) as integer
declare function DQBloadBMap (BMap as integer, FileName as string) as integer
declare function DQBsaveBMap (BMap as integer, FileName as string) as integer
declare sub DQBsetBMap (byval BMap as integer, byval ForeCol as integer, byval BackCol as integer, byval NewCol as integer)
declare function DQBgetBMap (byval BMap as integer, byval ForeCol as integer, byval BackCol as integer) as integer

' Procedures from KEYBOARD.OBJ:
declare sub DQBinstallKeyboard ()
declare sub DQBremoveKeyboard ()
declare function DQBkey (byval ScanCode as integer) as integer
declare function DQBreadKey () as integer
declare sub DQBwaitKey (byval ScanCode as integer)
declare function DQBasc (byval ScanCode as integer, byval ShiftFlag as integer) as integer
declare function qbstr(DQBinkey) () fbstr

' Procedures from JOYSTICK.OBJ:
declare function DQBjoyDetected (byval JoyNum as integer) as integer
declare function DQBjoyX (byval JoyNum as integer) as integer
declare function DQBjoyY (byval JoyNum as integer) as integer
declare function DQBjoyMove (byval JoyNum as integer, byval Direction as integer) as integer
declare function DQBjoyFire (byval JoyNum as integer, byval Button as integer) as integer
declare sub DQBpollJoy (byval JoyNum as integer)
declare sub DQBresetJoy ()
declare sub DQBsetJoySens (byval Sens as integer)

' Procedures from MOUSE.OBJ:
declare function DQBmouseDetected () as integer
declare function DQBmouseX () as integer
declare function DQBmouseY () as integer
declare function DQBmouseLB () as integer
declare function DQBmouseRB () as integer
declare sub DQBsetMousePos (byval x as integer, byval y as integer)
declare sub DQBmouseShow ()
declare sub DQBmouseHide ()
declare sub DQBsetMouseRange (byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer)
declare sub DQBsetMouseShape (hotX as integer, hotY as integer, Shape as string)
declare sub DQBsetMouseSpeed (byval HorSpeed as integer, byval VerSpeed as integer)
declare sub DQBresetMouse ()

' Procedures from SOUND.OBJ:
declare function DQBinstallSB (byval VolActive as integer, byval Channels as integer, byval Freq as integer, byval BaseAddr as integer, byval IRQ as integer, byval DMA as integer) as integer
declare function DQBloadSound (Slot as integer, FileName as string) as integer
declare function DQBloadRawSound (Slot as integer, FileName as string, Offset as long, Length as long) as integer
declare function DQBinUse (byval Voice as integer) as integer
declare sub DQBplaySound (byval SoundNum as integer, byval Voice as integer, byval Freq as integer, byval LoopFlag as integer)
declare sub DQBsetVoiceVol (byval Voice as integer, byval NewVol as integer)
declare sub DQBpauseSound ()
declare sub DQBresumeSound ()
declare sub DQBstopVoice (byval Voice as integer)
declare sub DQBremoveSB ()
declare sub DQBsetVolume (byval Volume as integer)

' Procedures from 3D.OBJ:
declare sub DQBtri (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval x3 as integer, byval y3 as integer, byval Col as integer)
declare sub DQBbtri (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval x3 as integer, byval y3 as integer, byval Col as integer, byval BMap as integer)
declare sub DQBgtri (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval c1 as integer, byval x2 as integer, byval y2 as integer, byval c2 as integer, byval x3 as integer, byval y3 as integer, byval c3 as integer)
declare sub DQBbgtri (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval c1 as integer, byval x2 as integer, byval y2 as integer, byval c2 as integer, byval x3 as integer, byval y3 as integer, byval c3 as integer, byval BMap as integer)
declare sub DQBttri (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval x3 as integer, byval y3 as integer, byval u1 as integer, byval v1 as integer, byval u2 as integer, byval v2 as integer, byval u3 as integer, byval v3 as integer, byval DummyTextureSeg as integer, byval TextureOff as any ptr)
declare sub DQBbttri (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval x3 as integer, byval y3 as integer, byval u1 as integer, byval v1 as integer, byval u2 as integer, byval v2 as integer, byval u3 as integer, byval v3 as integer, byval DummyTextureSeg as integer, byval TextureOff as any ptr, byval BMap as integer)
declare sub DQBfttri (byval Layer as integer, byval x1 as integer, byval y1 as integer, byval x2 as integer, byval y2 as integer, byval x3 as integer, byval y3 as integer, byval u1 as integer, byval v1 as integer, byval u2 as integer, byval v2 as integer, byval u3 as integer, byval v3 as integer, byval DummyTextureSeg as integer, byval TextureOff as any ptr)
declare sub DQBsetTextureSize (byval Size as integer)

' Library constants:
#ifndef false
const FALSE = 0, true = not FALSE
#endif
const VIDEO = 0
const B0 = &H8000+1, B1 = &H8001+1, B2 = &H8002+1, B3 = &H8003+1, B4 = &H8004+1
const B5 = &H8005+1, B6 = &H8006+1, B7 = &H8007+1, B8 = &H8008+2, B9 = &H8009+2
const BSV = 0, BMP = 1, PCX = 2
const HOR = 1, VER = 2, BOX = 0, PIXEL = 1, BIT_AND = 1, BIT_OR = 2, BIT_XOR = 3
const FORWARD = 0, BACKWARD = 1
const CENTERED = &H8000, NONE = 0, SOLID = &H1, BOLD = &H2, ITALIC = &H4
const UNDERLINED = &H8, BLENDED = &H10, TEXTURED = &H20
const ATTRIB_R = &H1, ATTRIB_H = &H2, ATTRIB_S = &H4
const ATTRIB_L = &H8, ATTRIB_D = &H10, ATTRIB_A = &H20
const KEYANY = -1, KEYESC = 1, KEYENTER = 28, KEYSPACE = 57
const KEYUP = 72, KEYDOWN = 80, KEYLEFT = 75, KEYRIGHT = 77
const cUP = 0, cDOWN = 1, cLEFT = 2, cRIGHT = 3
const JOY1 = 0, JOY2 = 1, GAMEPAD = 2
const BUTA = 0, BUTB = 1, BUTC = 2, BUTD = 3
const AUTO = -1, ONCE = 0, LOOPED = 1

